/**
 * \brief Instance header file for ATSAME54P20A
 *
 * Copyright (c) 2021 Microchip Technology Inc. and its subsidiaries.
 *
 * Subject to your compliance with these terms, you may use Microchip software and any derivatives
 * exclusively with Microchip products. It is your responsibility to comply with third party license
 * terms applicable to your use of third party software (including open source software) that may
 * accompany Microchip software.
 *
 * THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER EXPRESS, IMPLIED OR STATUTORY,
 * APPLY TO THIS SOFTWARE, INCLUDING ANY IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND
 * FITNESS FOR A PARTICULAR PURPOSE.
 *
 * IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, INCIDENTAL OR CONSEQUENTIAL
 * LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF
 * MICROCHIP HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO THE FULLEST EXTENT
 * ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT
 * EXCEED THE AMOUNT OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS SOFTWARE.
 *
 */

/* file generated from device description version 2021-04-16T09:25:23Z */
#ifndef _SAME54_I2S_INSTANCE_
#define _SAME54_I2S_INSTANCE_


/* ========== Instance Parameter definitions for I2S peripheral ========== */
#define I2S_CLK_NUM                              _UL_(2)    /* Number of clock units */
#define I2S_GCLK_ID_0                            _UL_(43)   /* Index of Generic Clock 0 */
#define I2S_GCLK_ID_1                            _UL_(44)   /* Index of Generic Clock 1 */
#define I2S_DMAC_ID_RX_0                         _UL_(76)   /* Index of DMA RX Trigger 0 */
#define I2S_DMAC_ID_RX_1                         _UL_(77)   /* Index of DMA RX Trigger 1 */
#define I2S_DMAC_ID_TX_0                         _UL_(78)   /* Index of DMA TX Trigger 0 */
#define I2S_DMAC_ID_TX_1                         _UL_(79)   /* Index of DMA TX Trigger 1 */
#define I2S_MAX_SLOTS                            _UL_(8)    /* Max number of data slots in frame */
#define I2S_MAX_WL_BITS                          _UL_(32)   /* Max number of bits in data samples */
#define I2S_SER_NUM                              _UL_(2)    /* Number of serializers */
#define I2S_INSTANCE_ID                          _UL_(106)  /* Instance index for I2S */

#endif /* _SAME54_I2S_INSTANCE_ */
