/**
 * \brief Instance header file for ATSAME54P20A
 *
 * Copyright (c) 2021 Microchip Technology Inc. and its subsidiaries.
 *
 * Subject to your compliance with these terms, you may use Microchip software and any derivatives
 * exclusively with Microchip products. It is your responsibility to comply with third party license
 * terms applicable to your use of third party software (including open source software) that may
 * accompany Microchip software.
 *
 * THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER EXPRESS, IMPLIED OR STATUTORY,
 * APPLY TO THIS SOFTWARE, INCLUDING ANY IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND
 * FITNESS FOR A PARTICULAR PURPOSE.
 *
 * IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, INCIDENTAL OR CONSEQUENTIAL
 * LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF
 * MICROCHIP HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO THE FULLEST EXTENT
 * ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT
 * EXCEED THE AMOUNT OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS SOFTWARE.
 *
 */

/* file generated from device description version 2021-04-16T09:25:23Z */
#ifndef _SAME54_RTC_INSTANCE_
#define _SAME54_RTC_INSTANCE_


/* ========== Instance Parameter definitions for RTC peripheral ========== */
#define RTC_DMAC_ID_TIMESTAMP                    _UL_(1)    /* DMA RTC timestamp trigger */
#define RTC_GPR_NUM                              _UL_(4)    /* Number of General-Purpose Registers */
#define RTC_NUM_OF_ALARMS                        _UL_(2)    /* Number of Alarms */
#define RTC_NUM_OF_BKREGS                        _UL_(8)    /* Number of Backup Registers */
#define RTC_NUM_OF_COMP16                        _UL_(4)    /* Number of 16-bit Comparators */
#define RTC_NUM_OF_COMP32                        _UL_(2)    /* Number of 32-bit Comparators */
#define RTC_NUM_OF_TAMPERS                       _UL_(5)    /* Number of Tamper Inputs */
#define RTC_PER_NUM                              _UL_(8)    /* Number of Periodic Intervals */
#define RTC_INSTANCE_ID                          _UL_(9)    /* Instance index for RTC */

#endif /* _SAME54_RTC_INSTANCE_ */
